!$Id:$
      subroutine pltmv(pl,ipl,u,nplts,save)

!      * * F E A P * * A Finite Element Analysis Program

!....  Copyright (c) 1984-2017: Regents of the University of California
!                               All rights reserved

!-----[--.----+----.----+----.-----------------------------------------]
!      Purpose: Extract information for time history from solution
!               array

!      Inputs:
!         ipl(*) - Location of information in u array
!         u(*)   - Array of values
!         nplts  - Number of items to extract
!         save   - Sign of quantity to save

!      Outputs:
!         pl(*)  - Array of time history information
!-----[--.----+----.----+----.-----------------------------------------]

      implicit  none

      real*8    save

      integer   nplts,j,n, ipl(2,nplts)
      real*8    pl(nplts),u(*)

      do n = 1,nplts
        j = ipl(1,n)
        if(j.gt.0) then
          pl(n) = u(j)*save
        end if
      end do

      end
